## suitesparse 5.1.2

=== Makefile ===
#-------------------------------------------------------------------------------
# Makefile for all SuiteSparse packages (except GraphBLAS)
#-------------------------------------------------------------------------------

SUITESPARSE = $(CURDIR)
export SUITESPARSE

default: go

include SuiteSparse_config/SuiteSparse_config.mk

# Compile the default rules for each package
go: metis
	( cd SuiteSparse_config && $(MAKE) )
	( cd GraphBLAS && $(MAKE) )
	( cd AMD && $(MAKE) )
	( cd BTF && $(MAKE) )
	( cd CAMD && $(MAKE) )
	( cd CCOLAMD && $(MAKE) )
	( cd COLAMD && $(MAKE) )
	( cd CHOLMOD && $(MAKE) )
	( cd CSparse && $(MAKE) )
	( cd CXSparse && $(MAKE) )
	( cd LDL && $(MAKE) )
	( cd KLU && $(MAKE) )
	( cd UMFPACK && $(MAKE) )
	( cd RBio && $(MAKE) )
ifneq ($(GPU_CONFIG),)
	( cd SuiteSparse_GPURuntime && $(MAKE) )
	( cd GPUQREngine && $(MAKE) )
endif
	( cd SPQR && $(MAKE) )
#	( cd PIRO_BAND && $(MAKE) )
#	( cd SKYLINE_SVD && $(MAKE) )

# install all packages in /usr/local/lib and /usr/local/include
# (note that CSparse is not installed; CXSparse is installed instead)
install: metisinstall
	( cd SuiteSparse_config && $(MAKE) install )
	( cd GraphBLAS && $(MAKE) install )
	( cd AMD && $(MAKE) install )
	( cd BTF && $(MAKE) install )
	( cd CAMD && $(MAKE) install )
	( cd CCOLAMD && $(MAKE) install )
	( cd COLAMD && $(MAKE) install )
	( cd CHOLMOD && $(MAKE) install )
	( cd CXSparse && $(MAKE) install )
	( cd LDL && $(MAKE) install )
	( cd KLU && $(MAKE) install )
	( cd UMFPACK && $(MAKE) install )
	( cd RBio && $(MAKE) install )
ifneq (,$(GPU_CONFIG))
	( cd SuiteSparse_GPURuntime && $(MAKE) install )
	( cd GPUQREngine && $(MAKE) install )
endif
	( cd SPQR && $(MAKE) install )
#	( cd PIRO_BAND && $(MAKE) install )
#	( cd SKYLINE_SVD && $(MAKE) install )
	$(CP) README.txt $(INSTALL_DOC)/SuiteSparse_README.txt
	chmod 644 $(INSTALL_DOC)/SuiteSparse_README.txt

metisinstall: metis
ifeq (,$(MY_METIS_LIB))
        # install METIS from SuiteSparse/metis-5.1.0
	@mkdir -p $(INSTALL_LIB)
	@mkdir -p $(INSTALL_INCLUDE)
	@mkdir -p $(INSTALL_DOC)
	- $(CP) lib/libmetis.* $(INSTALL_LIB)
	- $(CP) metis-5.1.0/manual/manual.pdf $(INSTALL_DOC)/METIS_manual.pdf
	- $(CP) metis-5.1.0/README.txt $(INSTALL_DOC)/METIS_README.txt
        # the following is needed only on the Mac, so *.dylib is hardcoded:
	$(SO_INSTALL_NAME) $(INSTALL_LIB)/libmetis.dylib $(INSTALL_LIB)/libmetis.dylib
	- $(CP) include/metis.h $(INSTALL_INCLUDE)
	chmod 755 $(INSTALL_LIB)/libmetis.*
	chmod 644 $(INSTALL_INCLUDE)/metis.h
	chmod 644 $(INSTALL_DOC)/METIS_manual.pdf
	chmod 644 $(INSTALL_DOC)/METIS_README.txt
endif

# uninstall all packages
uninstall:
	$(RM) $(INSTALL_DOC)/SuiteSparse_README.txt
	( cd SuiteSparse_config && $(MAKE) uninstall )
	- ( cd metis-5.1.0 && $(MAKE) uninstall )
	- ( cd GraphBLAS && $(MAKE) uninstall )
	( cd AMD && $(MAKE) uninstall )
	( cd CAMD && $(MAKE) uninstall )
	( cd COLAMD && $(MAKE) uninstall )
	( cd BTF && $(MAKE) uninstall )
	( cd KLU && $(MAKE) uninstall )
	( cd LDL && $(MAKE) uninstall )
	( cd CCOLAMD && $(MAKE) uninstall )
	( cd UMFPACK && $(MAKE) uninstall )
	( cd CHOLMOD && $(MAKE) uninstall )
	( cd CSparse && $(MAKE) uninstall )
	( cd CXSparse && $(MAKE) uninstall )
	( cd RBio && $(MAKE) uninstall )
	( cd SuiteSparse_GPURuntime && $(MAKE) uninstall )
	( cd GPUQREngine && $(MAKE) uninstall )
	( cd SPQR && $(MAKE) uninstall )
#	( cd PIRO_BAND && $(MAKE) uninstall )
#	( cd SKYLINE_SVD && $(MAKE) uninstall )
ifeq (,$(MY_METIS_LIB))
        # uninstall METIS, which came from SuiteSparse/metis-5.1.0
	$(RM) $(INSTALL_LIB)/libmetis.*
	$(RM) $(INSTALL_INCLUDE)/metis.h
	$(RM) $(INSTALL_DOC)/METIS_manual.pdf
	$(RM) $(INSTALL_DOC)/METIS_README.txt
endif
	$(RM) -r $(INSTALL_DOC)

# compile the dynamic libraries.  For GraphBLAS, this also builds the
# static library
library: metis
	( cd SuiteSparse_config && $(MAKE) )
	( cd GraphBLAS && $(MAKE) library )
	( cd AMD && $(MAKE) library )
	( cd BTF && $(MAKE) library )
	( cd CAMD && $(MAKE) library )
	( cd CCOLAMD && $(MAKE) library )
	( cd COLAMD && $(MAKE) library )
	( cd CHOLMOD && $(MAKE) library )
	( cd KLU && $(MAKE) library )
	( cd LDL && $(MAKE) library )
	( cd UMFPACK && $(MAKE) library )
	( cd CSparse && $(MAKE) library )
	( cd CXSparse && $(MAKE) library )
	( cd RBio && $(MAKE) library )
ifneq (,$(GPU_CONFIG))
	( cd SuiteSparse_GPURuntime && $(MAKE) library )
	( cd GPUQREngine && $(MAKE) library )
endif
	( cd SPQR && $(MAKE) library )
#	( cd PIRO_BAND && $(MAKE) library )
#	( cd SKYLINE_SVD && $(MAKE) library )

# compile the static libraries (except for metis and GraphBLAS.  metis is only
# dynamic, and the single 'make library' for GraphBLAS makes both the dynamic
# and static libraries.
static: metis
	( cd SuiteSparse_config && $(MAKE) static )
	( cd AMD && $(MAKE) static )
	( cd BTF && $(MAKE) static )
	( cd CAMD && $(MAKE) static )
	( cd CCOLAMD && $(MAKE) static )
	( cd COLAMD && $(MAKE) static )
	( cd CHOLMOD && $(MAKE) static )
	( cd KLU && $(MAKE) static )
	( cd LDL && $(MAKE) static )
	( cd UMFPACK && $(MAKE) static )
	( cd CSparse && $(MAKE) static )
	( cd CXSparse && $(MAKE) static )
	( cd RBio && $(MAKE) static )
ifneq (,$(GPU_CONFIG))
	( cd SuiteSparse_GPURuntime && $(MAKE) static )
	( cd GPUQREngine && $(MAKE) static )
endif
	( cd SPQR && $(MAKE) static )
#	( cd PIRO_BAND && $(MAKE) static )
#	( cd SKYLINE_SVD && $(MAKE) static )

# Remove all files not in the original distribution
purge:
	- ( cd SuiteSparse_config && $(MAKE) purge )
	- ( cd metis-5.1.0 && $(MAKE) distclean )
	- ( cd AMD && $(MAKE) purge )
	- ( cd GraphBLAS && $(MAKE) purge )
	- ( cd CAMD && $(MAKE) purge )
	- ( cd COLAMD && $(MAKE) purge )
	- ( cd BTF && $(MAKE) purge )
	- ( cd KLU && $(MAKE) purge )
	- ( cd LDL && $(MAKE) purge )
	- ( cd CCOLAMD && $(MAKE) purge )
	- ( cd UMFPACK && $(MAKE) purge )
	- ( cd CHOLMOD && $(MAKE) purge )
	- ( cd CSparse && $(MAKE) purge )
	- ( cd CXSparse && $(MAKE) purge )
	- ( cd RBio && $(MAKE) purge )
	- ( cd MATLAB_Tools/UFcollection && $(RM) *.mex* )
	- ( cd MATLAB_Tools/SSMULT && $(RM) *.mex* )
	- ( cd SuiteSparse_GPURuntime && $(MAKE) purge )
	- ( cd GPUQREngine && $(MAKE) purge )
	- ( cd SPQR && $(MAKE) purge )
#	- ( cd PIRO_BAND && $(MAKE) purge )
#	- ( cd SKYLINE_SVD && $(MAKE) purge )
	- $(RM) MATLAB_Tools/*/*.mex* MATLAB_Tools/spok/private/*.mex*
	- $(RM) -r include/* bin/* lib/* share/*

# Remove all files not in the original distribution, but keep the libraries
clean:
	- ( cd SuiteSparse_config && $(MAKE) clean )
	- ( cd metis-5.1.0 && $(MAKE) clean )
	- ( cd GraphBLAS && $(MAKE) clean )
	- ( cd AMD && $(MAKE) clean )
	- ( cd CAMD && $(MAKE) clean )
	- ( cd COLAMD && $(MAKE) clean )
	- ( cd BTF && $(MAKE) clean )
	- ( cd KLU && $(MAKE) clean )
	- ( cd LDL && $(MAKE) clean )
	- ( cd CCOLAMD && $(MAKE) clean )
	- ( cd UMFPACK && $(MAKE) clean )
	- ( cd CHOLMOD && $(MAKE) clean )
	- ( cd CSparse && $(MAKE) clean )
	- ( cd CXSparse && $(MAKE) clean )
	- ( cd RBio && $(MAKE) clean )
	- ( cd SuiteSparse_GPURuntime && $(MAKE) clean )
	- ( cd GPUQREngine && $(MAKE) clean )
	- ( cd SPQR && $(MAKE) clean )
#	- ( cd PIRO_BAND && $(MAKE) clean )
#	- ( cd SKYLINE_SVD && $(MAKE) clean )

# Create the PDF documentation
docs:
	( cd GraphBLAS && $(MAKE) docs )
	( cd AMD && $(MAKE) docs )
	( cd CAMD && $(MAKE) docs )
	( cd KLU && $(MAKE) docs )
	( cd LDL && $(MAKE) docs )
	( cd UMFPACK && $(MAKE) docs )
	( cd CHOLMOD && $(MAKE) docs )
	( cd SPQR && $(MAKE) docs )
#	( cd PIRO_BAND && $(MAKE) docs )
#	( cd SKYLINE_SVD && $(MAKE) docs )

distclean: purge

# Create CXSparse from CSparse
# Note that the CXSparse directory should initially not exist.
cx:
	( cd CSparse ; $(MAKE) purge )
	( cd SuiteSparse_config && $(MAKE) )
	( cd CXSparse_newfiles ; tar cfv - * | gzip -9 > ../CXSparse_newfiles.tar.gz )
	./CSparse_to_CXSparse CSparse CXSparse CXSparse_newfiles.tar.gz
	( cd CXSparse/Demo ; $(MAKE) )
	( cd CXSparse/Demo ; $(MAKE) > cs_demo.out )
	( cd CXSparse ; $(MAKE) purge )
	$(RM) -f CXSparse_newfiles.tar.gz

# statement coverage (Linux only); this requires a lot of time.
# The umfpack tcov requires a lot of disk space in /tmp
cov: purge
	( cd CXSparse && $(MAKE) cov )
	( cd CSparse && $(MAKE) cov )
	( cd CHOLMOD && $(MAKE) cov )
	( cd KLU && $(MAKE) cov )
	( cd SPQR && $(MAKE) cov )
	( cd UMFPACK && $(MAKE) cov )
#	( cd PIRO_BAND && $(MAKE) cov )
#	( cd SKYLINE_SVD && $(MAKE) cov )

# configure and compile METIS, placing the libmetis.* library in
# SuiteSparse/lib and the metis.h include file in SuiteSparse/include.
metis: include/metis.h

# Install the shared version of METIS in SuiteSparse/lib.
# The SO_INSTALL_NAME commmand is only needed on the Mac, so *.dylib is
# hardcoded below.
include/metis.h:
ifeq (,$(MY_METIS_LIB))
	- ( cd metis-5.1.0 && $(MAKE) config shared=1 prefix=$(SUITESPARSE) )
	- ( cd metis-5.1.0 && $(MAKE) )
	- ( cd metis-5.1.0 && $(MAKE) install )
	- $(SO_INSTALL_NAME) $(SUITESPARSE)/lib/libmetis.dylib \
                             $(SUITESPARSE)/lib/libmetis.dylib
else
	@echo 'Using pre-installed METIS 5.1.0 library at ' '[$(MY_METIS_LIB)]'
endif

=== CHOLMOD/Makefile ===
#-------------------------------------------------------------------------------
# CHOLMOD Makefile
#-------------------------------------------------------------------------------

SUITESPARSE ?= $(realpath $(CURDIR)/..)
export SUITESPARSE

default: all

include ../SuiteSparse_config/SuiteSparse_config.mk

# Compile the C-callable libraries and the Demo programs.
all:
	( cd Lib ; $(MAKE) )
	( cd Demo ; $(MAKE) )

# Compile the C-callable libraries only.
library:
	( cd Lib ; $(MAKE) )

# compile the static libraries only
static:
	( cd Lib    ; $(MAKE) static )

# Remove all files not in the original distribution
purge:
	( cd Tcov ; $(MAKE) purge )
	( cd Lib ; $(MAKE) purge )
	( cd Valgrind ; $(MAKE) dopurge )
	( cd Demo ; $(MAKE) purge )
	( cd Doc ; $(MAKE) purge )
	( cd MATLAB ; $(RM) $(CLEAN) rename.h *.mex* GKlib_util.c GKlib_graph.c )

# Remove all files not in the original distribution, except keep the 
# compiled libraries.
clean:
	( cd Tcov ; $(MAKE) clean )
	( cd Lib ; $(MAKE) clean )
	( cd Valgrind ; $(MAKE) clean )
	( cd Demo ; $(MAKE) clean )
	( cd MATLAB ; $(RM) $(CLEAN) )

distclean: purge

ccode: all

# Run the test coverage suite.  Takes about 40 minutes on a 3.2GHz Pentium.
# Requires Linux (gcc, gcov).
cov:
	( cd Tcov ; $(MAKE) )

# Run the test coverage suite using Valgrind.  This takes a *** long *** time.
valgrind:
	( cd Valgrind ; $(MAKE) )

# Compile the C-callable libraries and the Demo programs.
demos:
	( cd Demo ; $(MAKE) )

# create PDF documents for the original distribution
docs:
	( cd Doc    ; $(MAKE) )

# install CHOLMOD
install:
	( cd Lib ; $(MAKE) install )

# uninstall CHOLMOD
uninstall:
	( cd Lib ; $(MAKE) uninstall )

=== CSparse/Makefile ===
#------------------------------------------------------------------------------
# CSparse Makefile
#------------------------------------------------------------------------------

C:
	( cd Lib ; $(MAKE) )
	( cd Demo ; $(MAKE) )

all: C cov

library:
	( cd Lib ; $(MAKE) )

# compile the static libraries only
static:
	( cd Lib    ; $(MAKE) static )

cov:
	( cd Tcov ; $(MAKE) )

clean:
	( cd Lib ; $(MAKE) clean )
	( cd Demo ; $(MAKE) clean )
	( cd Tcov ; $(MAKE) clean )
	( cd MATLAB/CSparse ; $(RM) *.o )
	( cd MATLAB/Test    ; $(RM) *.o )

purge:
	( cd Lib ; $(MAKE) purge )
	( cd Demo ; $(MAKE) purge )
	( cd Tcov ; $(MAKE) purge )
	( cd MATLAB/CSparse ; $(RM) *.o *.mex* )
	( cd MATLAB/Test    ; $(RM) *.o *.mex* )

distclean: purge

install: library
	( cd Lib ; $(MAKE) install )

uninstall:
	( cd Lib ; $(MAKE) uninstall )

=== GraphBLAS/CMakeLists.txt ===
# SuiteSparse:GraphBLAS, Timothy A. Davis, (c) 2017, All Rights Reserved.
# http://suitesparse.com   See GraphBLAS/Doc/License.txt for license.
#
# CMakeLists.tx: instructions for cmake to build GraphBLAS.
# An ANSI C11 compiler is required.
#
# To compile the GraphBLAS library and demo programs:
#
#   cd build
#   cmake ..
#   make
#
# If that fails for any reason, make sure your compiler support ANSI C11.  You
# could try changing your compiler, for example, use one of these commands:
#
#   CC=icc cmake ..
#   CC=xlc cmake ..
#   CC=gcc cmake ..
#
# To run the demos:
#
#   cd ../Demo
#   ./demo
#
# To install GraphBLAS in /usr/local/lib and /usr/local/include:
#
#   cd build
#   sudo make install
#
# To remove all compiled files and libraries (except installed ones):
#
#   cd build
#   rm -rf *

# cmake 3.0 is prefered.
cmake_minimum_required ( VERSION 2.8.12 )

project ( graphblas )

include ( GNUInstallDirs )

if ( CMAKE_VERSION VERSION_GREATER "3.0" )
    cmake_policy ( SET CMP0042 NEW )
endif ( )

if (NOT CMAKE_BUILD_TYPE )
    set ( CMAKE_BUILD_TYPE Release )
endif ( )

# For development only, not for end-users:
# set ( CMAKE_BUILD_TYPE Debug )

set ( CMAKE_INCLUDE_CURRENT_DIR ON )

# include directories for both graphblas and graphblasdemo libraries
include_directories ( Source/Template Source Source/Generated Include Demo/Include )

# check which compiler is being used.  If you need to make
# compiler-specific modifications, here is the place to do it.
if ("${CMAKE_C_COMPILER_ID}" STREQUAL "GNU")
    # cmake 2.8 workaround: gcc needs to be told to do ANSI C11.
    # cmake 3.0 doesn't have this problem.
    set (CMAKE_C_FLAGS  "-std=c11 -lm -fopenmp")
    if (CMAKE_C_COMPILER_VERSION VERSION_LESS 4.9)
        message (FATAL_ERROR "gcc version must be at least 4.9")
    endif ( )
elseif ("${CMAKE_C_COMPILER_ID}" STREQUAL "Intel")
    # options for icc: also needs -std=c11
    set (CMAKE_C_FLAGS  "-std=c11 -fopenmp")
    if (CMAKE_C_COMPILER_VERSION VERSION_LESS 18.0)
        message (FATAL_ERROR "icc version must be at least 18.0")
    endif ( )
elseif ("${CMAKE_C_COMPILER_ID}" STREQUAL "Clang")
    # options for clang
    if (CMAKE_C_COMPILER_VERSION VERSION_LESS 3.3)
        message (FATAL_ERROR "clang version must be at least 3.3")
    endif ( )
elseif ("${CMAKE_C_COMPILER_ID}" STREQUAL "MSVC")
    # options for MicroSoft Visual Studio
endif ( )

# create the dynamic graphblas library.  Requires ANSI C11
file ( GLOB GRAPHBLAS_SOURCES "Source/*.c" "Source/Generated/*.c" )
add_library ( graphblas SHARED ${GRAPHBLAS_SOURCES} )
SET_TARGET_PROPERTIES ( graphblas PROPERTIES VERSION 1.1.2
    SOVERSION 1
    C_STANDARD_REQUIRED 11
    PUBLIC_HEADER "Include/GraphBLAS.h" )
set_property ( TARGET graphblas PROPERTY C_STANDARD 11 )

# create the static graphblas library.  Requires ANSI C11
add_library ( graphblas_static STATIC ${GRAPHBLAS_SOURCES} )
SET_TARGET_PROPERTIES ( graphblas_static PROPERTIES VERSION 1.1.2
    OUTPUT_NAME graphblas
    POSITION_INDEPENDENT_CODE OFF
    SOVERSION 1
    C_STANDARD_REQUIRED 11
    PUBLIC_HEADER "Include/GraphBLAS.h" )
set_property ( TARGET graphblas_static PROPERTY C_STANDARD 11 )

# Notes from Sebastien Villemot (sebastien@debian.org):
# SOVERSION policy: if a binary compiled against the old version of the shared
# library needs recompiling in order to work with the new version, then a
# SO_VERSION increase # is needed. Otherwise not.  Examples of the changes that
# require a SO_VERSION increase:
#
#   - a public function or static variable is removed
#   - the prototype of a public function changes
#   - the integer value attached to a public #define or enum changes
#   - the fields of a public structure are modified
#
# Examples of changes that do not require a SO_VERSION increase:
#
#   - a new public function or static variable is added
#   - a private function or static variable is removed or modified
#   - changes in the internals of a structure that is opaque to the calling
#       program (i.e. is only a pointer manipulated through public functions of
#       the library)
#   - a public enum is extended (by adding a new item at the end, but without
#       changing the already existing items)

# graphblas installation location
install ( TARGETS graphblas graphblas_static
    LIBRARY       DESTINATION ${CMAKE_INSTALL_LIBDIR}
    PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
    ARCHIVE       DESTINATION ${CMAKE_INSTALL_LIBDIR} )

# Demo library
file ( GLOB DEMO_SOURCES "Demo/Source/*.c" )
add_library ( graphblasdemo SHARED ${DEMO_SOURCES} )
SET_TARGET_PROPERTIES ( graphblasdemo PROPERTIES
    C_STANDARD_REQUIRED 11 )
set_property ( TARGET graphblasdemo PROPERTY C_STANDARD 11 )

add_library ( graphblasdemo_static STATIC ${DEMO_SOURCES} )
SET_TARGET_PROPERTIES ( graphblasdemo_static PROPERTIES
    C_STANDARD_REQUIRED 11 )
set_property ( TARGET graphblasdemo_static PROPERTY C_STANDARD 11 )

target_link_libraries ( graphblasdemo         m graphblas )
target_link_libraries ( graphblasdemo_static  graphblas_static )

# Demo programs
add_executable ( bfs_demo      "Demo/Program/bfs_demo.c" )
add_executable ( tri_demo      "Demo/Program/tri_demo.c" )
add_executable ( mis_demo      "Demo/Program/mis_demo.c" )
add_executable ( complex_demo  "Demo/Program/complex_demo.c" )
add_executable ( simple_demo   "Demo/Program/simple_demo.c" )
add_executable ( wildtype_demo "Demo/Program/wildtype_demo.c" )

# Libraries required for Demo programs
target_link_libraries ( bfs_demo      graphblas graphblasdemo )
target_link_libraries ( tri_demo      graphblas graphblasdemo )
target_link_libraries ( mis_demo      graphblas graphblasdemo )
target_link_libraries ( complex_demo  graphblas graphblasdemo )
target_link_libraries ( simple_demo   graphblasdemo )
target_link_libraries ( wildtype_demo graphblas )

=== GraphBLAS/Makefile ===
#-------------------------------------------------------------------------------
# GraphBLAS/Makefile
#-------------------------------------------------------------------------------

# SuiteSparse:GraphBLAS, Timothy A. Davis, (c) 2017, All Rights Reserved.
# http://suitesparse.com   See GraphBLAS/Doc/License.txt for license.

#-------------------------------------------------------------------------------

# simple Makefile for GraphBLAS, relies on cmake to do the actual build.  Use
# the CMAKE_OPTIONS argument to this Makefile to pass options to cmake.

# build the GraphBLAS library (static and dynamic) and run a quick test
default:
	( cd build ; cmake $(CMAKE_OPTIONS) .. ; $(MAKE) ; cd ../Demo ; ./demo )

# just build the static and dynamic libraries; do not run the demo
library:
	( cd build ; cmake $(CMAKE_OPTIONS) .. ; $(MAKE) )

# the same as "make library"
static: library

# installs GraphBLAS to the install location defined by cmake, usually
# /usr/local/lib and /usr/local/include
install:
	( cd build ; cmake $(CMAKE_OPTIONS) .. ; $(MAKE) ; $(MAKE) install )

# create the Doc/GraphBLAS_UserGuide.pdf
docs:
	( cd Doc ; $(MAKE) )

# remove any installed libraries and #include files
uninstall:
	- xargs rm < build/install_manifest.txt

clean: distclean

purge: distclean

# remove all files not in the distribution
distclean:
	rm -rf build/* Demo/*_demo.out Demo/complex_demo_out.m Tcov/log.txt
	( cd Test ; $(MAKE) distclean )
	( cd Tcov ; $(MAKE) distclean )
	( cd Doc  ; $(MAKE) distclean )

=== SPQR/Makefile ===
#-------------------------------------------------------------------------------
# SuiteSparseQR Makefile
#-------------------------------------------------------------------------------

SUITESPARSE ?= $(realpath $(CURDIR)/..)
export SUITESPARSE

default: all

include ../SuiteSparse_config/SuiteSparse_config.mk

all:
	( cd Lib ; $(MAKE) )
	( cd Demo ; $(MAKE) )

library:
	( cd Lib ; $(MAKE) )

# compile the static libraries only
static:
	( cd Lib    ; $(MAKE) static )

demos:
	( cd Demo ; $(MAKE) )

gpu:
	( cd Demo ; $(MAKE) gpu )

cov:
	( cd Tcov ; $(MAKE) )

purge:
	( cd Lib ; $(MAKE) purge )
	( cd Demo ; $(MAKE) purge )
	( cd Tcov ; $(MAKE) purge )
	( cd Doc ; $(MAKE) purge )
	( cd MATLAB ; $(RM) $(CLEAN) rename.h *.mex* )

clean:
	( cd Lib ; $(MAKE) clean )
	( cd Demo ; $(MAKE) clean )
	( cd MATLAB ; $(RM) $(CLEAN) rename.h )

distclean: purge

ccode: demos

# create PDF documents for the original distribution
docs:
	( cd Doc    ; $(MAKE) )

# install SPQR
install:
	( cd Lib ; $(MAKE) install )

# uninstall SPQR
uninstall:
	( cd Lib ; $(MAKE) uninstall )

=== SuiteSparse_config/Makefile ===
#-------------------------------------------------------------------------------
# SuiteSparse_config Makefile
#-------------------------------------------------------------------------------

SUITESPARSE ?= $(realpath $(CURDIR)/..)
export SUITESPARSE

# version of SuiteSparse_config is also version of SuiteSparse meta-package
LIBRARY = libsuitesparseconfig
VERSION = 5.1.2
SO_VERSION = 5

default: library

include SuiteSparse_config.mk

ccode: all

all: library

# compile and install in SuiteSparse/lib
library: $(AR_TARGET)
	$(MAKE) install INSTALL=$(SUITESPARSE)

OBJ = SuiteSparse_config.o

SuiteSparse_config.o: SuiteSparse_config.c SuiteSparse_config.h
	$(CC) $(CF) -c SuiteSparse_config.c

static: $(AR_TARGET)

$(AR_TARGET): $(OBJ)
	$(ARCHIVE) $(AR_TARGET) SuiteSparse_config.o
	$(RANLIB) $(AR_TARGET)

distclean: purge

purge: clean
	( cd xerbla ; $(MAKE) purge )
	- $(RM) -r $(PURGE)

clean:
	( cd xerbla ; $(MAKE) clean )
	- $(RM) -r $(CLEAN)

# install SuiteSparse_config
install: $(AR_TARGET) $(INSTALL_LIB)/$(SO_TARGET)

$(INSTALL_LIB)/$(SO_TARGET): $(OBJ)
	@mkdir -p $(INSTALL_LIB)
	@mkdir -p $(INSTALL_INCLUDE)
	@mkdir -p $(INSTALL_DOC)
	$(CC) $(SO_OPTS) $^ -o $@ $(LDLIBS)
	( cd $(INSTALL_LIB) ; ln -sf $(SO_TARGET) $(SO_PLAIN) )
	( cd $(INSTALL_LIB) ; ln -sf $(SO_TARGET) $(SO_MAIN) )
	$(CP) SuiteSparse_config.h $(INSTALL_INCLUDE)
	$(CP) README.txt $(INSTALL_DOC)/SUITESPARSECONFIG_README.txt
	chmod 755 $(INSTALL_LIB)/$(SO_TARGET)
	chmod 755 $(INSTALL_LIB)/$(SO_PLAIN)
	chmod 644 $(INSTALL_INCLUDE)/SuiteSparse_config.h
	chmod 644 $(INSTALL_DOC)/SUITESPARSECONFIG_README.txt

# uninstall SuiteSparse_config
uninstall:
	$(RM) $(INSTALL_LIB)/$(SO_TARGET)
	$(RM) $(INSTALL_LIB)/$(SO_PLAIN)
	$(RM) $(INSTALL_LIB)/$(SO_MAIN)
	$(RM) $(INSTALL_INCLUDE)/SuiteSparse_config.h
	$(RM) $(INSTALL_DOC)/SUITESPARSECONFIG_README.txt
	( cd xerbla ; $(MAKE) uninstall )

=== UMFPACK/Makefile ===
#-------------------------------------------------------------------------------
# UMFPACK Makefile
#-------------------------------------------------------------------------------

SUITESPARSE ?= $(realpath $(CURDIR)/..)
export SUITESPARSE

default: all

include ../SuiteSparse_config/SuiteSparse_config.mk

# compile all C code (except hb, fortran, and fortran64), incl. AMD and demos
all:
	( cd Lib    ; $(MAKE) )
	( cd Demo   ; $(MAKE) )

# compile just the C-callable UMFPACK library
library:
	( cd Lib    ; $(MAKE) )

# compile the static libraries only
static:
	( cd Lib    ; $(MAKE) static )

# compile the FORTRAN interface and demo program
fortran:
	( cd Demo   ; $(MAKE) fortran )

# compile the 64-bit FORTRAN interface and demo program
fortran64:
	( cd Demo   ; $(MAKE) fortran64 )

# compile the Harwell/Boeing demo program
hb:
	( cd Demo   ; $(MAKE) hb )

# remove object files, but keep the compiled programs and library archives
clean:
	( cd Lib    ; $(MAKE) clean )
	( cd Demo   ; $(MAKE) clean )
	( cd Doc    ; $(MAKE) clean )
	( cd MATLAB ; $(MAKE) clean )
	( cd MATLAB ; $(RM) $(CLEAN) rename.h )

# clean, and then remove compiled programs and library archives
purge:
	( cd Lib    ; $(MAKE) purge )
	( cd Demo   ; $(MAKE) purge )
	( cd Doc    ; $(MAKE) purge )
	( cd Tcov   ; $(MAKE) purge )
	( cd MATLAB ; $(MAKE) purge )

# create PDF documents for the original distribution
docs:
	( cd Doc    ; $(MAKE) )

# get ready for distribution
dist: purge
	( cd Demo   ; $(MAKE) dist )
	( cd Doc    ; $(MAKE) )

distclean: purge

ccode: library

lib: library

# statement coverage (requires Linux; takes a lot of time and disk space)
cov: purge
	( cd Tcov ; $(MAKE) )

# install UMFPACK
install:
	( cd Lib ; $(MAKE) install )

# uninstall UMFPACK
uninstall:
	( cd Lib ; $(MAKE) uninstall )

=== metis-5.1.0/Makefile ===
# Configuration options.
gdb        = not-set
assert     = not-set
assert2    = not-set
debug      = not-set
gprof      = not-set
openmp     = not-set
prefix     = not-set
gklib_path = not-set
shared     = not-set
cc         = not-set


# Basically proxies everything to the builddir cmake.

cputype = $(shell uname -m | sed "s/\\ /_/g")
systype = $(shell uname -s)

BUILDDIR = build/$(systype)-$(cputype)

# Process configuration options.
CONFIG_FLAGS = 
ifeq ($(gklib_path), not-set)
    gklib_path = GKlib
endif
CONFIG_FLAGS += -DGKLIB_PATH=$(abspath $(gklib_path))
ifneq ($(gdb), not-set)
    CONFIG_FLAGS += -DGDB=$(gdb)
endif
ifneq ($(assert), not-set)
    CONFIG_FLAGS += -DASSERT=$(assert)
endif
ifneq ($(assert2), not-set)
    CONFIG_FLAGS += -DASSERT2=$(assert2)
endif
ifneq ($(debug), not-set)
    CONFIG_FLAGS += -DDEBUG=$(debug)
endif
ifneq ($(gprof), not-set)
    CONFIG_FLAGS += -DGPROF=$(gprof)
endif
ifneq ($(openmp), not-set)
    CONFIG_FLAGS += -DOPENMP=$(openmp)
endif
ifneq ($(prefix), not-set)
    CONFIG_FLAGS += -DCMAKE_INSTALL_PREFIX=$(prefix)
endif
ifneq ($(shared), not-set)
    CONFIG_FLAGS += -DSHARED=1
endif
ifneq ($(cc), not-set)
    CONFIG_FLAGS += -DCMAKE_C_COMPILER=$(cc)
endif

VERNUM=5.1.0
PKGNAME=metis-$(VERNUM)

define run-config
mkdir -p $(BUILDDIR)
cd $(BUILDDIR) && cmake $(CURDIR) $(CONFIG_FLAGS)
endef

all clean install:
	@if [ ! -f $(BUILDDIR)/Makefile ]; then \
		more BUILD.txt; \
	else \
	  	make -C $(BUILDDIR) $@ $(MAKEFLAGS); \
	fi

uninstall:
	xargs rm < $(BUILDDIR)/install_manifest.txt

config: distclean
	$(run-config)

distclean:
	rm -rf $(BUILDDIR)

remake:
	find . -name CMakeLists.txt -exec touch {} ';'

dist:
	utils/mkdist.sh $(PKGNAME)

.PHONY: config distclean all clean install uninstall remake dist

=== ssget/Makefile ===
ssgui.jar:  ssgui.java sshelp.html
	javac ssgui.java
	jar cfe ssgui.jar ssgui *.class sshelp.html
	- $(RM) *.class

run: ssgui.jar
	java -jar ssgui.jar

clean:
	- $(RM) *.class

purge:
	- $(RM) *.class

check:
	javac -Xlint:deprecation -Xlint:unchecked ssgui.java

=== CHOLMOD/Lib/Makefile ===
#===============================================================================
# CHOLMOD/Lib/Makefile: for compiling the CHOLMOD library
#===============================================================================

LIBRARY = libcholmod
VERSION = 3.0.11
SO_VERSION = 3

default: library

ccode: all

include ../../SuiteSparse_config/SuiteSparse_config.mk

# CHOLMOD depends on AMD, SuiteSparse_config, LAPACK, BLAS,
# and optionally METIS, CAMD, and CCOLAMD if the Partition Module is in use
LDLIBS += -lamd -lcolamd -lsuitesparseconfig \
	$(LIB_WITH_PARTITION) $(LAPACK) $(BLAS)

SO_OPTS += $(CFOPENMP)

#-------------------------------------------------------------------------------
# With the CUDA BLAS:
ifneq ($(GPU_CONFIG),)
LDLIBS += $(CUDART_LIB) $(CUBLAS_LIB)
endif
#-------------------------------------------------------------------------------

# compile and install in SuiteSparse/lib
library:
	$(MAKE) install INSTALL=$(SUITESPARSE)

#-------------------------------------------------------------------------------

I = -I../../AMD/Include -I../../AMD/Source -I../../COLAMD/Include \
	$(I_WITH_PARTITION) -I../Include -I../../SuiteSparse_config \
	$(CUDA_INC)

#-------------------------------------------------------------------------------

C = $(CC) $(CF) $(CHOLMOD_CONFIG) $(CONFIG_PARTITION)

all: library

purge: distclean

distclean: clean
	- $(RM) -r $(PURGE)

clean:
	- $(RM) -r $(CLEAN)

#-------------------------------------------------------------------------------
# ../Include/ directory contains all include files:
#-------------------------------------------------------------------------------

INC =   ../Include/cholmod.h \
	../Include/cholmod_blas.h \
	../Include/cholmod_check.h \
	../Include/cholmod_cholesky.h \
	../Include/cholmod_complexity.h \
	../Include/cholmod_config.h \
	../Include/cholmod_core.h \
	../Include/cholmod_internal.h \
	../Include/cholmod_matrixops.h \
	../Include/cholmod_modify.h \
	../Include/cholmod_partition.h \
	../Include/cholmod_supernodal.h \
	../Include/cholmod_template.h \
	../Include/cholmod_gpu.h

#-------------------------------------------------------------------------------
# The 7 CHOLMOD library modules (int, double)
#-------------------------------------------------------------------------------

CORE = cholmod_aat.o cholmod_add.o cholmod_band.o \
	cholmod_change_factor.o cholmod_common.o cholmod_complex.o \
	cholmod_copy.o cholmod_dense.o cholmod_error.o cholmod_factor.o \
	cholmod_memory.o cholmod_sparse.o \
	cholmod_transpose.o cholmod_triplet.o \
        cholmod_version.o

CHECK = cholmod_check.o cholmod_read.o cholmod_write.o

CHOLESKY = cholmod_amd.o cholmod_analyze.o cholmod_colamd.o \
	cholmod_etree.o cholmod_factorize.o cholmod_postorder.o \
	cholmod_rcond.o cholmod_resymbol.o cholmod_rowcolcounts.o \
	cholmod_rowfac.o cholmod_solve.o cholmod_spsolve.o

MATRIXOPS = cholmod_drop.o cholmod_horzcat.o cholmod_norm.o \
	cholmod_scale.o cholmod_sdmult.o cholmod_ssmult.o \
	cholmod_submatrix.o cholmod_vertcat.o cholmod_symmetry.o

PARTITION = cholmod_ccolamd.o cholmod_csymamd.o \
	cholmod_metis.o cholmod_nesdis.o cholmod_camd.o

MODIFY = cholmod_rowadd.o cholmod_rowdel.o cholmod_updown.o

SUPERNODAL = cholmod_super_numeric.o cholmod_super_solve.o \
	cholmod_super_symbolic.o

ifneq ($(GPU_CONFIG),)
GPU = cholmod_gpu.o cholmod_gpu_kernels.o
else
GPU =
endif

DI = $(CORE) $(CHECK) $(CHOLESKY) $(MATRIXOPS) $(MODIFY) $(SUPERNODAL) \
	$(GPU) $(PARTITION) 

#-------------------------------------------------------------------------------
# CHOLMOD library modules (long, double)
#-------------------------------------------------------------------------------

LCORE = cholmod_l_aat.o cholmod_l_add.o cholmod_l_band.o \
	cholmod_l_change_factor.o cholmod_l_common.o cholmod_l_complex.o \
	cholmod_l_copy.o cholmod_l_dense.o cholmod_l_error.o \
	cholmod_l_factor.o cholmod_l_memory.o \
	cholmod_l_sparse.o cholmod_l_transpose.o cholmod_l_triplet.o \
        cholmod_l_version.o

LCHECK = cholmod_l_check.o cholmod_l_read.o cholmod_l_write.o

LCHOLESKY = cholmod_l_amd.o cholmod_l_analyze.o cholmod_l_colamd.o \
	cholmod_l_etree.o cholmod_l_factorize.o cholmod_l_postorder.o \
	cholmod_l_rcond.o cholmod_l_resymbol.o cholmod_l_rowcolcounts.o \
	cholmod_l_rowfac.o cholmod_l_solve.o cholmod_l_spsolve.o

LMATRIXOPS = cholmod_l_drop.o cholmod_l_horzcat.o cholmod_l_norm.o \
	cholmod_l_scale.o cholmod_l_sdmult.o cholmod_l_ssmult.o \
	cholmod_l_submatrix.o cholmod_l_vertcat.o cholmod_l_symmetry.o

LPARTITION = cholmod_l_ccolamd.o cholmod_l_csymamd.o \
	cholmod_l_metis.o cholmod_l_nesdis.o cholmod_l_camd.o

LMODIFY = cholmod_l_rowadd.o cholmod_l_rowdel.o cholmod_l_updown.o

LSUPERNODAL = cholmod_l_super_numeric.o cholmod_l_super_solve.o \
	cholmod_l_super_symbolic.o

ifneq ($(GPU_CONFIG),)
LGPU = cholmod_l_gpu.o cholmod_gpu_kernels.o
else
LGPU =
endif

DL = $(LCORE) $(LCHECK) $(LCHOLESKY) $(LMATRIXOPS) $(LMODIFY) $(LSUPERNODAL) \
	$(LPARTITION) $(LGPU)

#-------------------------------------------------------------------------------

# to compile just the double/int version, use OBJ = $(DI)
OBJ = $(DI) $(DL)

static: $(AR_TARGET)

$(AR_TARGET): $(OBJ)
	$(ARCHIVE) $@ $^
	- $(RANLIB) $@

$(OBJ): $(INC)

#-------------------------------------------------------------------------------
# Check Module:
#-------------------------------------------------------------------------------

cholmod_check.o: ../Check/cholmod_check.c
	$(C) -c $(I) $<

cholmod_read.o: ../Check/cholmod_read.c
	$(C) -c $(I) $<

cholmod_write.o: ../Check/cholmod_write.c
	$(C) -c $(I) $<

#-------------------------------------------------------------------------------

cholmod_l_check.o: ../Check/cholmod_check.c
	$(C) -DDLONG -c $(I) $< -o $@

cholmod_l_read.o: ../Check/cholmod_read.c
	$(C) -DDLONG -c $(I) $< -o $@

cholmod_l_write.o: ../Check/cholmod_write.c
	$(C) -DDLONG -c $(I) $< -o $@


#-------------------------------------------------------------------------------
# Core Module:
#-------------------------------------------------------------------------------

cholmod_common.o: ../Core/cholmod_common.c
	$(C) -c $(I) $<

cholmod_dense.o: ../Core/cholmod_dense.c ../Core/t_cholmod_dense.c
	$(C) -c $(I) $<

cholmod_factor.o: ../Core/cholmod_factor.c
	$(C) -c $(I) $<

cholmod_change_factor.o: ../Core/cholmod_change_factor.c \
	../Core/t_cholmod_change_factor.c
	$(C) -c $(I) $<

cholmod_memory.o: ../Core/cholmod_memory.c
	$(C) -c $(I) $<

cholmod_sparse.o: ../Core/cholmod_sparse.c
	$(C) -c $(I) $<

cholmod_complex.o: ../Core/cholmod_complex.c
	$(C) -c $(I) $<

cholmod_transpose.o: ../Core/cholmod_transpose.c ../Core/t_cholmod_transpose.c
	$(C) -c $(I) $<

cholmod_band.o: ../Core/cholmod_band.c
	$(C) -c $(I) $<

cholmod_copy.o: ../Core/cholmod_copy.c
	$(C) -c $(I) $<

cholmod_triplet.o: ../Core/cholmod_triplet.c ../Core/t_cholmod_triplet.c
	$(C) -c $(I) $<

cholmod_error.o: ../Core/cholmod_error.c
	$(C) -c $(I) $<

cholmod_aat.o: ../Core/cholmod_aat.c
	$(C) -c $(I) $<

cholmod_add.o: ../Core/cholmod_add.c
	$(C) -c $(I) $<

cholmod_version.o: ../Core/cholmod_version.c
	$(C) -c $(I) $<

#-------------------------------------------------------------------------------

cholmod_l_common.o: ../Core/cholmod_common.c
	$(C) -DDLONG -c $(I) $< -o $@

cholmod_l_dense.o: ../Core/cholmod_dense.c ../Core/t_cholmod_dense.c
	$(C) -DDLONG -c $(I) $< -o $@

cholmod_l_factor.o: ../Core/cholmod_factor.c
	$(C) -DDLONG -c $(I) $< -o $@

cholmod_l_change_factor.o: ../Core/cholmod_change_factor.c \
	../Core/t_cholmod_change_factor.c
	$(C) -DDLONG -c $(I) $< -o $@

cholmod_l_memory.o: ../Core/cholmod_memory.c
	$(C) -DDLONG -c $(I) $< -o $@

cholmod_l_sparse.o: ../Core/cholmod_sparse.c
	$(C) -DDLONG -c $(I) $< -o $@

cholmod_l_complex.o: ../Core/cholmod_complex.c
	$(C) -DDLONG -c $(I) $< -o $@

cholmod_l_transpose.o: ../Core/cholmod_transpose.c ../Core/t_cholmod_transpose.c
	$(C) -DDLONG -c $(I) $< -o $@

cholmod_l_band.o: ../Core/cholmod_band.c
	$(C) -DDLONG -c $(I) $< -o $@

cholmod_l_copy.o: ../Core/cholmod_copy.c
	$(C) -DDLONG -c $(I) $< -o $@

cholmod_l_triplet.o: ../Core/cholmod_triplet.c ../Core/t_cholmod_triplet.c
	$(C) -DDLONG -c $(I) $< -o $@

cholmod_l_error.o: ../Core/cholmod_error.c
	$(C) -DDLONG -c $(I) $< -o $@

cholmod_l_aat.o: ../Core/cholmod_aat.c
	$(C) -DDLONG -c $(I) $< -o $@

cholmod_l_add.o: ../Core/cholmod_add.c
	$(C) -DDLONG -c $(I) $< -o $@

cholmod_l_version.o: ../Core/cholmod_version.c
	$(C) -DDLONG -c $(I) $< -o $@


#-------------------------------------------------------------------------------
# Cholesky Module:
#-------------------------------------------------------------------------------

cholmod_amd.o: ../Cholesky/cholmod_amd.c
	$(C) -c $(I) $<

cholmod_analyze.o: ../Cholesky/cholmod_analyze.c
	$(C) -c $(I) $<

cholmod_colamd.o: ../Cholesky/cholmod_colamd.c
	$(C) -c $(I) $<

cholmod_etree.o: ../Cholesky/cholmod_etree.c
	$(C) -c $(I) $<

cholmod_factorize.o: ../Cholesky/cholmod_factorize.c
	$(C) -c $(I) $<

cholmod_postorder.o: ../Cholesky/cholmod_postorder.c
	$(C) -c $(I) $<

cholmod_rcond.o: ../Cholesky/cholmod_rcond.c
	$(C) -c $(I) $<

cholmod_resymbol.o: ../Cholesky/cholmod_resymbol.c
	$(C) -c $(I) $<

cholmod_rowcolcounts.o: ../Cholesky/cholmod_rowcolcounts.c
	$(C) -c $(I) $<

cholmod_solve.o: ../Cholesky/cholmod_solve.c ../Cholesky/t_cholmod_lsolve.c \
	../Cholesky/t_cholmod_ltsolve.c ../Cholesky/t_cholmod_solve.c
	$(C) -c $(I) $<

cholmod_spsolve.o: ../Cholesky/cholmod_spsolve.c
	$(C) -c $(I) $<

cholmod_rowfac.o: ../Cholesky/cholmod_rowfac.c ../Cholesky/t_cholmod_rowfac.c
	$(C) -c $(I) $<

#-------------------------------------------------------------------------------

cholmod_l_amd.o: ../Cholesky/cholmod_amd.c
	$(C) -DDLONG -c $(I) $< -o $@

cholmod_l_analyze.o: ../Cholesky/cholmod_analyze.c
	$(C) -DDLONG -c $(I) $< -o $@

cholmod_l_colamd.o: ../Cholesky/cholmod_colamd.c
	$(C) -DDLONG -c $(I) $< -o $@

cholmod_l_etree.o: ../Cholesky/cholmod_etree.c
	$(C) -DDLONG -c $(I) $< -o $@

cholmod_l_factorize.o: ../Cholesky/cholmod_factorize.c
	$(C) -DDLONG -c $(I) $< -o $@

cholmod_l_postorder.o: ../Cholesky/cholmod_postorder.c
	$(C) -DDLONG -c $(I) $< -o $@

cholmod_l_rcond.o: ../Cholesky/cholmod_rcond.c
	$(C) -DDLONG -c $(I) $< -o $@

cholmod_l_resymbol.o: ../Cholesky/cholmod_resymbol.c
	$(C) -DDLONG -c $(I) $< -o $@

cholmod_l_rowcolcounts.o: ../Cholesky/cholmod_rowcolcounts.c
	$(C) -DDLONG -c $(I) $< -o $@

cholmod_l_solve.o: ../Cholesky/cholmod_solve.c ../Cholesky/t_cholmod_lsolve.c \
	../Cholesky/t_cholmod_ltsolve.c ../Cholesky/t_cholmod_solve.c
	$(C) -DDLONG -c $(I) $< -o $@

cholmod_l_spsolve.o: ../Cholesky/cholmod_spsolve.c
	$(C) -DDLONG -c $(I) $< -o $@

cholmod_l_rowfac.o: ../Cholesky/cholmod_rowfac.c ../Cholesky/t_cholmod_rowfac.c
	$(C) -DDLONG -c $(I) $< -o $@

#-------------------------------------------------------------------------------
# Partition Module:
#-------------------------------------------------------------------------------

cholmod_ccolamd.o: ../Partition/cholmod_ccolamd.c
	$(C) -c $(I) $<

cholmod_csymamd.o: ../Partition/cholmod_csymamd.c
	$(C) -c $(I) $<

cholmod_camd.o: ../Partition/cholmod_camd.c
	$(C) -c $(I) $<

cholmod_metis.o: ../Partition/cholmod_metis.c
	$(C) -c $(I) $<

cholmod_nesdis.o: ../Partition/cholmod_nesdis.c
	$(C) -c $(I) $<

#-------------------------------------------------------------------------------

cholmod_l_ccolamd.o: ../Partition/cholmod_ccolamd.c
	$(C) -DDLONG -c $(I) $< -o $@

cholmod_l_csymamd.o: ../Partition/cholmod_csymamd.c
	$(C) -DDLONG -c $(I) $< -o $@

cholmod_l_camd.o: ../Partition/cholmod_camd.c
	$(C) -DDLONG -c $(I) $< -o $@

cholmod_l_metis.o: ../Partition/cholmod_metis.c
	$(C) -DDLONG -c $(I) $< -o $@

cholmod_l_nesdis.o: ../Partition/cholmod_nesdis.c
	$(C) -DDLONG -c $(I) $< -o $@


#-------------------------------------------------------------------------------
# MatrixOps Module:
#-------------------------------------------------------------------------------

=== CSparse/Tcov/Makefile ===
# To run with valgrind:
V =
# V = valgrind -q

# Linux test coverage
CC = gcc
CFLAGS = -O -g -fprofile-arcs -ftest-coverage \
    	-Wall -W -Wshadow -Wmissing-prototypes -Wstrict-prototypes \
    	-Wredundant-decls -Wnested-externs -Wdisabled-optimization -ansi \
	-Wno-unused-parameter -I../Include -I../Demo

run: all run1 runbook run3 runtest
	./covall

all: cs_demo1 cs_demo2 cs_demo3 cstcov_test

CS = cs_add.o cs_amd.o cs_chol.o cs_cholsol.o cs_counts.o cs_cumsum.o \
	cs_droptol.o cs_dropzeros.o cs_dupl.o cs_entry.o \
	cs_etree.o cs_fkeep.o cs_gaxpy.o cs_happly.o cs_house.o cs_ipvec.o \
	cs_lsolve.o cs_ltsolve.o cs_lu.o cs_lusol.o cs_util.o cs_multiply.o \
	cs_permute.o cs_pinv.o cs_post.o cs_pvec.o cs_qr.o cs_qrsol.o \
	cs_scatter.o cs_schol.o cs_sqr.o cs_symperm.o cs_tdfs.o \
	cs_transpose.o cs_compress.o cs_usolve.o cs_scc.o cs_maxtrans.o \
	cs_dmperm.o cs_updown.o cs_print.o cs_norm.o cs_load.o cs_dfs.o \
	cstcov_malloc_test.o cs_utsolve.o cs_reach.o cs_spsolve.o cs_ereach.o \
	cs_leaf.o cs_randperm.o

$(CS): ../Include/cs.h cstcov_malloc_test.h

.PRECIOUS: cs_%.c cs_dem%.c

cs_dem%.c:
	- ln -s ../Demo/$@

cs_%.c:
	- ln -s ../Source/$@

cs_demo1: $(CS) cs_demo1.c
	$(CC) $(CFLAGS) -o cs_demo1 cs_demo1.c $(CS) -lm

cs_demo2: $(CS) cs_demo2.c cs_demo.c
	$(CC) $(CFLAGS) -o cs_demo2 cs_demo2.c cs_demo.c $(CS) -lm

cs_demo3: $(CS) cs_demo3.c cs_demo.c
	$(CC) $(CFLAGS) -o cs_demo3 cs_demo3.c cs_demo.c $(CS) -lm

cstcov_test: $(CS) cstcov_test.c cs_demo.c
	$(CC) $(CFLAGS) -o cstcov_test cstcov_test.c cs_demo.c $(CS) -lm

# tiny tests
run1: all
	- $(V) ./cs_demo1 < nil
	- $(V) ./cs_demo1 < zero
	- $(V) ./cs_demo2 < nil
	- $(V) ./cs_demo2 < zero
	- $(V) ./cs_demo3 < nil

# test coverage for book:
runbook: all
	- $(V) ./cs_demo1 < ../Matrix/t1
	- $(V) ./cs_demo2 < ../Matrix/bcsstk01
	- $(V) ./cs_demo2 < ../Matrix/fs_183_1
	- $(V) ./cs_demo2 < ../Matrix/mbeacxc
	- $(V) ./cs_demo2 < ../Matrix/west0067
	- $(V) ./cs_demo2 < ../Matrix/lp_afiro
	- $(V) ./cs_demo3 < ../Matrix/bcsstk16

# other tests
run3: all
	- $(V) ./cs_demo2 < ../Matrix/t1
	- $(V) ./cs_demo2 < ../Matrix/ash219
	- $(V) ./cs_demo3 < ../Matrix/bcsstk01
	- $(V) ./cs_demo2 < ../Matrix/bcsstk16
	- $(V) ./cs_demo2 < ../Matrix/ibm32a
	- $(V) ./cs_demo2 < ../Matrix/ibm32b

# exhaustive memory tests
runtest: all
	- $(V) ./cstcov_test nil > test_nil.out
	- $(V) ./cstcov_test zero > test_zero.out
	- $(V) ./cstcov_test ../Matrix/t1 > test_t1.out
	- $(V) ./cstcov_test ../Matrix/bcsstk01 > test_k1.out
	- $(V) ./cstcov_test ../Matrix/fs_183_1 > test_fs.out
	- $(V) ./cstcov_test ../Matrix/west0067 > test_we.out
	- $(V) ./cstcov_test ../Matrix/ash219 > test_ash.out
	- $(V) ./cstcov_test ../Matrix/lp_afiro > test_afiro.out

readhb: readhb.f
	f77 -o readhb readhb.f

readhb.f:
	- ln -s readhb.f

clean:
	- $(RM) *.o *.bbg *.da *.gcov *.gcda *.gcno

purge: distclean

# remove everything for distribution, including all symbolic links
distclean: clean
	- $(RM) cs_demo1 cs_demo2 readhb *.out *.a cs_demo3 cstcov_test cov.sort
	- $(RM) -r cs_*.c *.dSYM

=== debian/changelog ===
suitesparse (1:5.1.2-2) unstable; urgency=medium

  * Add missing Depends of libsuitesparse-dev on libgraphblas1.
    (Closes: #887570)

 -- Sébastien Villemot <sebastien@debian.org>  Fri, 19 Jan 2018 18:09:10 +0100

suitesparse (1:5.1.2-1) unstable; urgency=medium

  * New upstream version 5.1.2
  * Update Vcs-* fields for move to salsa.debian.org.

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 07 Jan 2018 11:46:33 +0100

suitesparse (1:5.1.2~beta2-1) unstable; urgency=medium

  * New upstream version 5.1.2~beta2
    + libgraphblasdemo now linked against libm. (Closes: #885569)
  * Bump Standards-Version to 4.1.3.

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 02 Jan 2018 14:04:44 +0100

suitesparse (1:5.1.2~beta-2) unstable; urgency=medium

  * Upload to unstable.

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 27 Dec 2017 10:12:05 +0100

suitesparse (1:5.1.2~beta-1) experimental; urgency=medium

  * New upstream version 5.1.2~beta
  * graphblas-build.patch: drop patch, applied upstream.
  * d/watch: support -beta suffix (treating it as ~beta).
  * d/rules: remove kludge for renaming static GraphBLAS lib.
  * Bump to debhelper compat level 11:
    - documentation now installed under /u/s/doc/libsuitesparse-dev
    - directly call make instead of dh_auto_build (the latter messes up with the
      INSTALL parameter)

 -- Sébastien Villemot <sebastien@debian.org>  Mon, 25 Dec 2017 22:14:41 +0100

suitesparse (1:5.1.1-beta-1) experimental; urgency=medium

  * New upstream version 5.1.1-beta
    - fixes FTBFS on some 32-bit platforms (Closes: #884564)
    - static GraphBLAS library is now shipped in -dev package.
  * Drop patches applied upstream: cmake.patch, pdf-docs.patch.
  * graphblas-build.patch: new patch for GraphBLAS build system.
  * Update symbols file for libgraphblas1.
  * Add missing epoch in symbols files.

 -- Sébastien Villemot <sebastien@debian.org>  Thu, 21 Dec 2017 21:36:15 +0100

suitesparse (1:5.1.0-1) experimental; urgency=medium

  * New upstream version 5.1.0
  * d/copyright: reflect upstream changes.
  * SOVERSION bump for libsuitesparseconfig (4 -> 5).
  * Package new GraphBLAS library:
    + new libgraphblas1 package.
    + add Build-Depends on cmake.
    + cmake.patch: new patch, fixes installation paths of the library.
    + install GraphBLAS.h include in libsuitesparse-dev.
    + install GraphBLAS_Userguide.pdf, and register it into doc-base.
  * Rebuild PDF doc.
    + add some texlive build-depedencies.
    + new pdf-docs.patch
  * d/rules: drop obsolete override for dbgsym migration.
  * Bump to Standards-Version 4.1.2.
  * Install README.txt in libsuitesparse-doc (instead of libamd2).
  * Drop useless README.Debian.
  * Add source lintian override for insecure URL in d/watch.

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 09 Dec 2017 22:21:24 +0100

=== debian/control ===
Source: suitesparse
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Sébastien Villemot <sebastien@debian.org>
Section: math
Priority: optional
Build-Depends: debhelper (>= 11),
               gfortran,
               libblas-dev,
               liblapack-dev,
               libmetis-dev,
               cmake,
               texlive-latex-extra,
               texlive-plain-generic,
               texlive-bibtex-extra
Standards-Version: 4.1.3
Vcs-Browser: https://salsa.debian.org/science-team/suitesparse
Vcs-Git: https://salsa.debian.org/science-team/suitesparse.git
Homepage: http://www.suitesparse.com

Package: libamd2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: approximate minimum degree ordering library for sparse matrices
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 The AMD library provides a set of routines for pre-ordering sparse matrices
 prior to Cholesky or LU factorization, using the "Approximate Minimum Degree
 ordering" algorithm.

Package: libbtf1
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: permutation to block triangular form library for sparse matrices
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 The BTF library is a software package for permuting a matrix into Block upper
 Triangular Form. It includes a maximum transversal algorithm, which finds a
 permutation of a square or rectangular matrix so that it has a zero-free
 diagonal (if one exists); otherwise, it finds a maximal matching which
 maximizes the number of nonzeros on the diagonal. The package also includes a
 method for finding the strongly connected components of a graph. These two
 methods together give the permutation to block upper triangular form.

Package: libcamd2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: symmetric approximate minimum degree library for sparse matrices
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 The CAMD library provides a set of routines for pre-ordering sparse matrices
 prior to Cholesky or LU factorization, using the approximate minimum degree
 ordering algorithm with optional ordering constraints.

Package: libcolamd2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: column approximate minimum degree ordering library for sparse matrices
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 The COLAMD library implements the "COLumn Approximate Minimum Degree ordering"
 algorithm. It computes a permutation vector P such that the LU factorization
 of A (:,P) tends to be sparser than that of A. The Cholesky factorization of
 (A (:,P))'*(A (:,P)) will also tend to be sparser than that of A'*A.

Package: libccolamd2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: constrained column approximate library for sparse matrices
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 The CCOLAMD library implements the "Constrained COLumn Approximate Minimum
 Degree ordering" algorithm. It computes a permutation vector P such that the
 LU factorization of A (:,P) tends to be sparser than that of A. The Cholesky
 factorization of (A (:,P))'*(A (:,P)) will also tend to be sparser than that
 of A'*A.

Package: libcholmod3
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: sparse Cholesky factorization library for sparse matrices
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 The CHOLMOD library provides a set of routines for factorizing sparse
 symmetric positive definite matrices of the form A or AA', updating/downdating
 a sparse Cholesky factorization, solving linear systems, updating/downdating
 the solution to the triangular system Lx=b, and many other sparse matrix
 functions for both symmetric and unsymmetric matrices. Its supernodal Cholesky
 factorization relies on LAPACK and the Level-3 BLAS, and obtains a substantial
 fraction of the peak performance of the BLAS.

Package: libcxsparse3
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: concise sparse matrix library
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 The CXSparse library provides several matrix algorithms. The focus is on direct
 methods; iterative methods and solvers for eigenvalue problems are beyond the
 scope of this package.
 .
 The performance of the sparse factorization methods in CXSparse will not be
 competitive with UMFPACK or CHOLMOD, but the codes are much more concise and
 easy to understand. Other methods are competitive.

Package: libklu1
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: circuit simulation sparse LU factorization library
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 The KLU library provides routines for LU factorization, primarily for circuit
 simulation.

Package: libldl2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: simple LDL' factorization library for sparse matrices
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 The LDL library provides routines for sparse LDL' factorization and solving.
 These routines are not terrifically fast (they do not use dense matrix
 kernels), but the code is very short and concise. The purpose is to illustrate
 the algorithms in a very concise and readable manner, primarily for
 educational purposes.

Package: libumfpack5
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: sparse LU factorization library
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 The UMFPACK library provides a set of routines solving sparse linear systems
 via LU factorization.

Package: librbio2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: read/write sparse matrices in Rutherford/Boeing format
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 RBio is a library for reading/writing sparse matrices in the Rutherford/Boeing
 format.

Package: libspqr2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: sparse QR factorization library
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 SuiteSparseQR (SPQR) is a multithreaded, multifrontal, rank-revealing sparse
 QR factorization method.

Package: libgraphblas1
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: graph algorithms via sparse matrix operations on semirings
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 SuiteSparse:GraphBLAS is an full implementation of the GraphBLAS standard,
 which defines a set of sparse matrix operations on an extended algebra of
 semirings using an almost unlimited variety of operators and types. When
 applied to sparse adjacency matrices, these algebraic operations are
 equivalent to computations on graphs. GraphBLAS provides a powerful and
 expressive framework for creating graph algorithms based on the elegant
 mathematics of sparse matrix operations on a semiring.

Package: libsuitesparseconfig5
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: configuration routines for all SuiteSparse modules
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 The SuiteSparse_config library provides configuration routines that are common
 to all SuiteSparse libraries.

Package: libsuitesparse-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libamd2 (= ${binary:Version}),
         libcamd2 (= ${binary:Version}),
         libbtf1 (= ${binary:Version}),
         libcolamd2 (= ${binary:Version}),
         libccolamd2 (= ${binary:Version}),
         libcholmod3 (= ${binary:Version}),
         libcxsparse3 (= ${binary:Version}),
         libgraphblas1 (= ${binary:Version}),
         libklu1 (= ${binary:Version}),
         libldl2 (= ${binary:Version}),
         libumfpack5 (= ${binary:Version}),
         librbio2 (= ${binary:Version}),
         libspqr2 (= ${binary:Version}),
         libsuitesparseconfig5 (= ${binary:Version}),
         libblas-dev | libblas.so,
         liblapack-dev | liblapack.so
Conflicts: libsuitesparse-metis-dev
Replaces: libsuitesparse-metis-dev
Description: libraries for sparse matrices computations (development files)
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.  This package includes the following libraries:
 .
 AMD         approximate minimum degree ordering
 .
 CAMD        symmetric approximate minimum degree
 .
 BTF         permutation to block triangular form (beta)
 .
 COLAMD      column approximate minimum degree ordering
 .
 CCOLAMD     constrained column approximate minimum degree ordering
 .
 CHOLMOD     sparse Cholesky factorization
 .
 CXSparse    a concise sparse matrix package
 .
 KLU         sparse LU factorization, primarily for circuit simulation
 .
 LDL         a simple LDL' factorization
 .
 UMFPACK     sparse LU factorization
 .
 RBio        read/write sparse matrices in Rutherford/Boeing format
 .
 SPQR        sparse QR factorization
 .
 GraphBLAS   graph algorithms via sparse matrix operations on semirings
 .
 SuiteSparse_config    configuration routines for all the above packages.
 .
 This package contains the static libraries and header files.

Package: libsuitesparse-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Suggests: liblapack-doc,
          libatlas-doc
Description: libraries for sparse matrices computations (documentation)
 Suitesparse is a collection of libraries for computations involving
 sparse matrices. This package contains the user guides for the
 libraries distributed by the SuiteSparse project.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

# Flags for traditional Makefiles (all libs except GraphBLAS)
COMMON_FLAGS := BLAS=-lblas MY_METIS_LIB=-lmetis
PIC_FLAGS := $(COMMON_FLAGS) OPTIMIZATION=-fPIC
NOPIC_FLAGS := $(COMMON_FLAGS) OPTIMIZATION=

# Flags for cmake (only GraphBLAS)
export CMAKE_OPTIONS := -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_VERBOSE_MAKEFILE=ON -DCMAKE_C_FLAGS_RELEASE="$(CFLAGS) $(CPPFLAGS)" -DCMAKE_CXX_FLAGS_RELEASE="$(CXXFLAGS) $(CPPFLAGS)"

# All static libs (except GraphBLAS static which is handled by cmake)
STATIC_LIBS := CAMD/Lib/libcamd.a BTF/Lib/libbtf.a CHOLMOD/Lib/libcholmod.a AMD/Lib/libamd.a RBio/Lib/librbio.a LDL/Lib/libldl.a SuiteSparse_config/libsuitesparseconfig.a KLU/Lib/libklu.a SPQR/Lib/libspqr.a UMFPACK/Lib/libumfpack.a COLAMD/Lib/libcolamd.a CXSparse/Lib/libcxsparse.a CCOLAMD/Lib/libccolamd.a

PDF_DOCS := AMD/Doc/AMD_UserGuide.pdf CAMD/Doc/CAMD_UserGuide.pdf CHOLMOD/Doc/CHOLMOD_UserGuide.pdf GraphBLAS/Doc/GraphBLAS_UserGuide.pdf KLU/Doc/KLU_UserGuide.pdf UMFPACK/Doc/UMFPACK_QuickStart.pdf UMFPACK/Doc/UMFPACK_UserGuide.pdf LDL/Doc/ldl_userguide.pdf SPQR/Doc/spqr_user_guide.pdf

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
NUMJOBS := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
NUMJOBS := 1
endif


%:
	dh $@

# LD_LIBRARY_PATH needed to make tests work (since buildflags.patch removes the -rpath)
override_dh_auto_build:
	# Docs must be rebuilt first, because the build system expect them for some libs
	rm -f $(PDF_DOCS)
	make docs

	# Build static libraries (except GraphBLAS, see graphblas-build.patch)
	make -j$(NUMJOBS) static $(NOPIC_FLAGS)
	mkdir static_lib && cp $(STATIC_LIBS) static_lib/
	make purge

	# Build dynamic libraries (and GraphBLAS static)
	LD_LIBRARY_PATH=$$(pwd)/lib make -j$(NUMJOBS) $(PIC_FLAGS)

override_dh_auto_install:
	# DESTDIR is used by cmake (for GraphBLAS), the INSTALL* vars are used by other libs
	make install $(PIC_FLAGS) INSTALL=$$(pwd)/debian/tmp/usr INSTALL_LIB=$$(pwd)/debian/tmp/usr/lib/${DEB_HOST_MULTIARCH}/ INSTALL_INCLUDE=$$(pwd)/debian/tmp/usr/include/suitesparse INSTALL_DOC=$$(pwd)/debian/tmp/usr/share/doc/suitesparse DESTDIR=$$(pwd)/debian/tmp
	# Install static libraries (except GraphBLAS)
	cp static_lib/* debian/tmp/usr/lib/${DEB_HOST_MULTIARCH}/

override_dh_auto_clean:
	make purge
	rm -rf static_lib
	rm -f $(PDF_DOCS)

override_dh_makeshlibs:
	dh_makeshlibs -V

override_dh_compress:
	dh_compress -X.pdf

get-orig-source:
	uscan --force-download --rename --destdir .
.PHONY: get-orig-source

=== debian/watch ===
version=4
opts="uversionmangle=s/-beta/~beta/" http://www.suitesparse.com \
(?:|.*/)SuiteSparse(?:[_\-]v?|)(\d[^\s/]*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)
